<!-- TalentList.svelte -->
<script lang="ts">
  import Talent from './Talent.svelte'
  import { getLocalizer } from '../../../module/utils.js'
  import { TalentCategory } from '../../../module/enums.js'
  import { getContext } from 'svelte'
  import { CharacterDataAccessor } from '../../../module/model/character.js'
  import { Writable } from 'svelte/store'
  import { hasName } from '../../../module/model/utils.js'

  const localize = getLocalizer()

  let doc = getContext<Writable<CharacterDataAccessor>>('doc')

  $: talents = $doc.talents

  export let talentCategories: (typeof TalentCategory)[keyof typeof TalentCategory][] =
    [
      TalentCategory.Combat,
      TalentCategory.Physical,
      TalentCategory.Social,
      TalentCategory.Nature,
      TalentCategory.Knowledge,
      TalentCategory.Crafting,
      TalentCategory.Language,
      TalentCategory.Gift,
    ]

  let selectedCategory: string | undefined
  function select(category: string | undefined) {
    if (category === selectedCategory) {
      selectedCategory = undefined
    } else {
      selectedCategory = category
    }
  }

  $: filteredTalents = talents
    .filter(hasName)
    .sort((a, b) => a.name.localeCompare(b.name))
    .filter(
      (talent) =>
        talentCategories.includes(talent.system.category as any) &&
        (selectedCategory === undefined ||
          talent.system.category === selectedCategory)
    )

  $: showCategories = talentCategories.length > 1
</script>

{#if showCategories}
  <div class="categories" data-testid="category-filter">
    {#each talentCategories as category}
      <!-- svelte-ignore a11y-click-events-have-key-events a11y-no-static-element-interactions a11y-missing-attribute -->
      <a
        on:click={() => select(category)}
        class:selectedCategory={category == selectedCategory}
        >{localize(category)}</a
      >
    {/each}
  </div>
{/if}

<div class="talents">
  <div class="head flexrow">
    <div class="talent-label">{localize('name')}</div>
    <div class="flexrow" style:width="33%">
      <div>{localize('effectiveEncumbaranceAbbr')}</div>
      <div>AT/FK</div>
      <div>PA</div>
      <div>TaW</div>
    </div>
  </div>
  {#each filteredTalents as talent}
    <div class="talent">
      <Talent bind:talent />
    </div>
  {/each}
</div>

<style>
  .talent:nth-child(even) {
    background-color: rgba(255, 255, 255, 0.2);
  }

  .head {
    font-size: medium;
    margin-top: 20px;
    font-weight: bold;
  }

  .categories {
    display: flex;
    text-decoration: underline;
    text-align: center;

    justify-content: space-evenly;
  }

  .selectedCategory {
    font-weight: bold;
    font-style: italic;
  }
</style>
